/*********************************************************************
*
*@USBڑ IVXR[v
*	USBt-[NC
*@@RtBM[V̐ݒύX
*    CDCNXx[X
*@@main.c@̕ύX@폜@IOݒύX
*@@io_cfg.h̕ύX@LED폜@IOj^폜
*@@user.c̕ύX@@폜
*@@usbcfg.h̕ύX@IOj^폜
*  LinkerCĂ̂ŒӁ
*
*********************************************************************

/** I N C L U D E S ************************************************/
#include <p18cxxx.h>
#include "system\typedefs.h"                 // Required
#include "system\usb\usb.h"                  // Required
#include "io_cfg.h"                          // Required

#include "system\usb\usb_compile_time_validation.h"

/*** Configuration *******/
#pragma config FOSC = HSPLL_HS
#pragma config WDT = OFF
#pragma config PLLDIV = 5
#pragma config CPUDIV = OSC1_PLL2
#pragma config USBDIV = 2
#pragma config PWRT = ON
#pragma config BOR = ON
#pragma config BORV = 43
#pragma config LVP = OFF
#pragma config VREGEN = ON
#pragma config MCLRE = ON
#pragma config PBADEN = OFF

/** V A R I A B L E S **********************************************/
#pragma udata
static char input_buffer[64];			// USB̓obt@
static char output_buffer[64];			// USBo̓obt@

unsigned int RcvSize;					// Mf[^TCY
char State = 0;						// Xe[gtO
unsigned int Period;					// Tv
unsigned int Index = 0;				// obt@CfbNX
char FreeFlag;						// t[tO
byte New_Data;						// f[^
byte Old_Data;						// Of[^
byte Threshold;						// gKpXbVh
byte Sample;							// TvO
byte Channel;							// `lԍ

rom char MsgOK[] ="OK";				// OKbZ[W
// AiOvobt@@v960oCg
#pragma udata gpr1 
static byte BufferA[448];				// ő512̓G[
#pragma udata usb6
static byte BufferB[512];				// LinkerProtect͂

/** P R I V A T E  P R O T O T Y P E S ******************************/
void ltostring(char digit, unsigned long data, byte *buffer);
byte AD_input(char chanl);
void ISRProcess(void);

/** V E C T O R  R E M A P P I N G **********************************/
extern void _startup (void);        			// 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800
void _reset (void)
{
    _asm goto _startup _endasm
}
#pragma code
#pragma code high_vector=0x08
void interrupt_at_high_vector(void)
{
    _asm goto ISRProcess _endasm
}
#pragma code low_vector=0x18
void interrupt_at_low_vector(void)
{

}
#pragma code

/*****************************************/
/* CCP1̊荞ݏ
/* A/DϊsMTvO
/* ŒZ10sec\50sec
/****************************************/
#pragma interrupt ISRProcess
void ISRProcess(void)
{
	PIR1bits.CCP1IF = 0;					// 荞݃tONA
	Old_Data = New_Data;					// pɂQ
	New_Data = AD_input(Channel);			// VKf[^TvO
   	//// gKoƕۑ
   	switch (State)
   	{
   		case 0:		/// gKo
   			if(FreeFlag == 0) {
	   			if(Threshold > 127) {			// vX̎͗オgK
	  	 			if((Old_Data < Threshold) && (New_Data > Threshold)) {
		  	 			State = 1;
		  	 			Index = 0;
		  	 		}
		  	 	}
		  	 	else {						// }CiX̎͗gK
			  	 	if((Old_Data > Threshold) && (New_Data < Threshold)) {
				  	 	State = 1;
				  	 	Index = 0;
				  	 }
				}
			}
			else {
				State = 1;
				Index = 0;
			}			
	  	 	break;
	 	case 1:		/// f[^i[
	         if(Index <448) {				// ܂Aobt@Ɋi[
	   	      	GreenLED = !GreenLED;		         
				BufferA[Index++] = New_Data;
			}
			else {						// Bobt@Ɋi[
				if(Index < 960) {
	   	      		YellowLED = !YellowLED;	
					BufferB[Index-448] = New_Data;
					Index++;
				}
				else {					// obt@tŃXe[gXV
					State = 2;
					Index = 0;
					T1CONbits.TMR1ON = 0;	// ^C}P~
				}
			}
			break;
		default: break;
	}
}
//////// A/Dϊǂݍ݊֐
byte AD_input(char chanl)
{
    	byte adData;        				// 8rbg[h
    	
	ADCON0 = 0x01 + (chanl * 4);
    	ADCON0bits.GO = 1;              	// Start AD conversion
    	while(ADCON0bits.NOT_DONE);     	// Wait for conversion
 	adData = (byte)ADRESH;				// ʂWrbĝݎo
	return(adData);                    	// f[^Ԃ
}


/**********************************************************
 * C֐
 * USBM҂AMR}hɉs
 *********************************************************/
void main(void)
{
	int	i;
	
	ADCON1 = 0x07;             	// |[gASAiOɐݒ
	ADCON2 = 0x16;				// Left,TadTcy/64 Taq=4Tad 
	ADCON0 = 0x1D;				// AD On	
	CMCON = 0x07;					// Rp[^It
	/// |[g	
   	LATB = 0xFF;					// LEDIt
 	TRISA = 0xFF;					// AiO
	TRISB = 0x00;					// LEDo
 	TRISC = 0xB0;					// USB
 	// ^C}P
 	T1CON = 0xB0;					// NbN vXP[1/8
 	TMR1H = 0;					//  = 48MHz/4/8=1.5MHz
 	TMR1L = 0;
	T3CON = 0;					// CCP1vŃ^C}PZbg
 	// CCP1
 	Period = 15;					// 10usec PʂƂ
 	CCP1CON = 0x0B;				// vŃ^C}PNA
	CCPR1 = Period * 10;			// 10usecP(10usec to 40.390msec)	
	/// USB
	mInitializeUSBDriver();        	// See usbdrv.h
	/// ϐ
	State = 0;					// Xe[gtOZbg
	Threshold = 190;				// gKvXbVhl
	Sample =10;					// Tvl100usec
	FreeFlag = 1;					// t[tOI
	Channel = 0;					// `lԍ0
	T1CONbits.TMR1ON = 0;			// ^C}~
	// 荞݋
	RCONbits.IPEN = 0;			// D揇ʂȂ
 	PIE1bits.CCP1IE = 1;			// CCP1荞݋		
	INTCON = 0xC0;				// O[o荞݋

    /// C[v
    while(1)
    {
    		USBCheckBusStatus();        							// USBڑ`FbN
    		if(UCFGbits.UTEYE!=1)									// ACp^[[hIt
        		USBDriverService();								// USBCxg|[O
		CDCTxService();										// NXMs
 		/// Mf[^̏s
		if((usb_device_state >= CONFIGURED_STATE)&&(UCONbits.SUSPND==0))
		{
    			if(getsUSBUSART(input_buffer,64))					// f[^M|[
    			{
				RedLED = !RedLED;								// ڈLED
	    			switch(input_buffer[0])						// ŏ̂P`FbN
	    			{
		    			case '0':								// OKbZ[Wԑ
						State = 0;
        					if(mUSBUSARTIsTxTrfReady())
           			 		putrsUSBUSART("OK");
           			 	break;
           			case '1':								// f[^WJnR}h
           				State = 0;							// Xe[gԃZbg
           				T1CONbits.TMR1ON = 1;					// ^C}PX^[g
           				Threshold = (byte)input_buffer[1];		// XbVh擾
           				Sample = (byte)input_buffer[2];			// TvO擾
           				CCPR1 = Period * Sample;				// ݒ10usecP
           				Channel = (byte)input_buffer[3];		// `lԍݒ
	    					FreeFlag = 0;							// t[It           				
           				break;	
           			case '2':								// Ԗ₢킹
           				if(State == 2) {						// f[^擾H
        						if(mUSBUSARTIsTxTrfReady())	         					
           			 			putrsUSBUSART("1");			// ȂPԂ
           			 	}
           			 	else {
       						if(mUSBUSARTIsTxTrfReady())
           			 			putrsUSBUSART("0");			// ȂOԂ
           			 	}
           			 	break;
		    			case '3':								// vf[^M
				  		if((Index < 448) && (State == 2)) {		// obt@ȂM
							/// vf[^448oCg]
						 	if(mUSBUSARTIsTxTrfReady())
           			 			mUSBUSARTTxRam(&BufferA[Index], 64);	// Ms
							Index += 64;
						}									
						else {								// obt@B̑M
							if((State == 2) && (Index < 960)) {
							 	if(mUSBUSARTIsTxTrfReady())
							 		mUSBUSARTTxRam(&BufferB[Index-448], 64);
								Index += 64;
							}
							else							// MŃXe[gZbg
								State = 0;
						}
		    				break;
		    			case '4':								// t[w
           				State = 0;							// Xe[gԃZbg
           				T1CONbits.TMR1ON = 1;					// ^C}PX^[g
           				Threshold = (byte)input_buffer[1];		// XbVh擾
           				Sample = (byte)input_buffer[2];			// TvO擾
           				CCPR1 = Period * Sample;				// ݒ10usecP
            				Channel = (byte)input_buffer[3];		// `lԍݒ          				
	    					FreeFlag = 1;							// t[I          				
           				break;			    			
		    			default: break;
		    		}
    			}
    		}
     }
}

